Bug 98518 - [x86_64] gcc generates invalid asm code when "-O -fPIC" is used (suffix or operands invalid for `movabs')
Summary: [x86_64] gcc generates invalid asm code when "-O -fPIC" is used (suffix or op...
Status: CLOSED RAWHIDE
Alias: None
Product: Red Hat Raw Hide
Classification: Retired
Component: gcc (Show other bugs)
(Show other bugs)
Version: 1.0
Hardware: x86_64 Linux
medium
high
Target Milestone: ---
Assignee: Jakub Jelinek
QA Contact:
URL: http://gcc.gnu.org/bugzilla/show_bug....
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2003-07-03 06:11 UTC by Aleksey Nogin
Modified: 2007-04-18 16:55 UTC (History)
2 users (show)

Fixed In Version: 3.2.3-9, 3.3-13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-08-05 16:29:28 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
A small exaple that triggers the bug. (179 bytes, text/plain)
2003-07-03 06:14 UTC, Aleksey Nogin
no flags Details

Description Aleksey Nogin 2003-07-03 06:11:17 UTC
Reproducible: 100%

To reproduce, run "gcc -O -fPIC -c bug.c" (I will attach a small self-contained
bug.c shortly).

Expected: it compiles (or produces an error message if the source is not a valid
C program).

Actual:

/tmp/ccMEmtFi.s: Assembler messages:
/tmp/ccMEmtFi.s:14: Error: suffix or operands invalid for `movabs'
Exit 1

This bug comes up when trying to compile OCaml (current CVS head) on x86_64
under a recent Rawhide tree.

Note that both -O and -fPIC options are necessary to reproduce (without one or
both of them, the file compiles fine).

% gcc -v
Reading specs from /usr/lib/gcc-lib/x86_64-redhat-linux/3.3/specs
Configured with: ../configure --prefix=/usr --mandir=/usr/share/man
--infodir=/usr/share/info --enable-shared --enable-threads=posix
--disable-checking --with-system-zlib --enable-__cxa_atexit
--host=x86_64-redhat-linux
Thread model: posix
gcc version 3.3 20030623 (Red Hat Linux 3.3-12)

Comment 1 Aleksey Nogin 2003-07-03 06:14:55 UTC
Created attachment 92731 [details]
A small exaple that triggers the bug.

Comment 2 Aleksey Nogin 2003-07-03 06:24:10 UTC
I also reported this upstream - see
http://gcc.gnu.org/bugzilla/show_bug.cgi?id=11420

Comment 4 Aleksey Nogin 2003-07-08 20:33:59 UTC
I see that a fix was just committed to the gcc CVS. Can I expect this to appear
in the Rawhide tree some time soon, or am I better off just compiling it myself?


Note You need to log in before you can comment on or make changes to this bug.